package org.acceleo.gen.ui.wizards.export.template;

public class CreateMainJavaGenerator
{
  protected static String nl;
  public static synchronized CreateMainJavaGenerator create(String lineSeparator)
  {
    nl = lineSeparator;
    CreateMainJavaGenerator result = new CreateMainJavaGenerator();
    nl = null;
    return result;
  }

  public final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "";
  protected final String TEXT_2 = NL + "package ";
  protected final String TEXT_3 = ";";
  protected final String TEXT_4 = NL + NL + "import java.io.File;";
  protected final String TEXT_5 = NL + "import java.util.Map;";
  protected final String TEXT_6 = NL + NL + "import org.acceleo.engine.EMT;" + NL + "import fr.obeo.acceleo.gen.template.eval.LaunchManager;" + NL + "import org.acceleo.gen.AcceleoGenerate;";
  protected final String TEXT_7 = NL + "import org.acceleo.gen.EcoreModel;";
  protected final String TEXT_8 = NL + "import org.acceleo.gen.Model;";
  protected final String TEXT_9 = NL + "import org.acceleo.gen.extension.Extension;" + NL + "import org.acceleo.tools.resources.Resources;" + NL + "import org.eclipse.emf.common.util.URI;" + NL + "import org.eclipse.emf.ecore.resource.ResourceSet;" + NL;
  protected final String TEXT_10 = NL + "import org.eclipse.emf.ecore.EcorePackage;" + NL + "import org.eclipse.emf.ecore.EPackage;" + NL + "import org.eclipse.emf.ecore.resource.URIConverter;" + NL + "import org.eclipse.emf.mapping.ecore2xml.Ecore2XMLPackage;" + NL + "import org.eclipse.emf.mapping.ecore2xml.util.Ecore2XMLResource;" + NL + "import org.eclipse.uml2.uml.UMLPackage;" + NL + "import org.eclipse.uml2.uml.resource.UML22UMLExtendedMetaData;" + NL + "import org.eclipse.uml2.uml.resource.UML22UMLResource;" + NL + "import org.eclipse.uml2.uml.resource.UMLResource;";
  protected final String TEXT_11 = NL + NL + "/**" + NL + " * Generated using Acceleo export." + NL + " */" + NL + "public class ";
  protected final String TEXT_12 = " {" + NL + "" + NL + "\t" + NL + "\t/**" + NL + "\t * Execute ";
  protected final String TEXT_13 = " template using the given model" + NL + "\t * " + NL + "\t * @param args" + NL + "\t *            args[0] : model resource args[1] : generation path" + NL + "\t * @throws Exception" + NL + "\t */" + NL + "\tpublic static void main(String[] args) throws Exception {" + NL + "\t\tif (args.length == 1) {" + NL + "\t\t\tgenerate(args[0]);" + NL + "\t\t} else if (args.length == 2) {" + NL + "\t\t\tgenerateFolder(args[0], args[1]);" + NL + "\t\t} else {" + NL + "\t\t\tSystem.out.println(\"args: <model_path> [<generation_directory>]\");" + NL + "\t\t\tSystem.out.println(\"      - model_path is the path of the model to use for the generation\");" + NL + "\t\t\tSystem.out.println(\"      - generation_directory is the path that will be used to store generated files\");" + NL + "\t\t}" + NL + "\t}" + NL + "\t" + NL + "\tpublic static void generate(String modelPath) throws Exception{" + NL + "\t\tString emtFile = \"";
  protected final String TEXT_14 = "\";" + NL + "\t\tAcceleoGenerate generator = new AcceleoGenerate();" + NL + "\t\tgenerator.setGenRootDir(System.getProperty(\"user.dir\") + File.separator + \"generated\" + File.separator);" + NL + "\t\tResourceSet resourceSet = getResourceSet();" + NL + "\t\t";
  protected final String TEXT_15 = NL + "\t\tEcoreModel model = new EcoreModel(resourceSet, getModelURI(";
  protected final String TEXT_16 = ".class.getResource(\"";
  protected final String TEXT_17 = "\").getFile()), getModelURI(modelPath));" + NL + "\t\t";
  protected final String TEXT_18 = NL + "\t\tModel model = new Model(resourceSet,\"";
  protected final String TEXT_19 = "\", getModelURI(modelPath));" + NL + "\t\t";
  protected final String TEXT_20 = NL + "\t\tEMT emt = new EMT(resourceSet, getEMTURI(emtFile),Thread.currentThread().getContextClassLoader());" + NL + "\t\tgenerator.generate(emt, model, true, LaunchManager.create(\"run\", false));" + NL + "\t}" + NL + "\t" + NL + "\tpublic static void generateFolder(String modelPath, String generatePath) throws Exception{" + NL + "\t\tString emtFile = \"";
  protected final String TEXT_21 = "\";" + NL + "\t\tAcceleoGenerate generator = new AcceleoGenerate();" + NL + "\t\tgenerator.setGenRootDir(generatePath);" + NL + "\t\tResourceSet resourceSet = getResourceSet();" + NL + "\t\t";
  protected final String TEXT_22 = NL + "\t\tEcoreModel model = new EcoreModel(resourceSet, getModelURI(";
  protected final String TEXT_23 = ".class.getResource(\"";
  protected final String TEXT_24 = "\").getFile()), getModelURI(modelPath));" + NL + "\t\t";
  protected final String TEXT_25 = NL + "\t\tModel model = new Model(resourceSet,\"";
  protected final String TEXT_26 = "\", getModelURI(modelPath));" + NL + "\t\t";
  protected final String TEXT_27 = NL + "\t\tEMT emt = new EMT(resourceSet, getEMTURI(emtFile), Thread.currentThread().getContextClassLoader());" + NL + "\t\tgenerator.generate(emt, model, true, LaunchManager.create(\"run\", false));" + NL + "\t}" + NL + "\t" + NL + "\tprivate static URI getModelURI(String name) throws Exception {" + NL + "\t\tURI ret = null;" + NL + "\t\tif(new File(name).exists()){" + NL + "\t\t\tret = URI.createFileURI(name);" + NL + "\t\t}" + NL + "\t\telse {" + NL + "\t\t\tret = Resources.getResourceURI(name);" + NL + "\t\t}" + NL + "\t\tif(ret == null){" + NL + "\t\t\tthrow new Exception(\"Unable to find model \" + name);" + NL + "\t\t}" + NL + "\t\treturn ret;" + NL + "\t}" + NL + "\t" + NL + "\tprivate static URI getEMTURI(String name) throws Exception{" + NL + "\t\tURI ret = Resources.getResourceURI(name);" + NL + "\t\tif(ret == null){" + NL + "\t\t\tthrow new Exception(\"Unable to find emt \" + name);" + NL + "\t\t}" + NL + "\t\treturn ret;" + NL + "\t}" + NL + "\t" + NL + "\tprivate static ResourceSet getResourceSet(){" + NL + "\t\tResourceSet ret = Extension.getResourceSet();" + NL + "\t\t";
  protected final String TEXT_28 = NL + "\t\t// registerPathmaps" + NL + "\t\tURI umlResourcePluginURI = URI.createURI(\"jar:file:/";
  protected final String TEXT_29 = "!/\");" + NL + "\t\tMap<URI, URI> uriMap = ret.getURIConverter().getURIMap();" + NL + "\t\turiMap.put(URI.createURI(UMLResource.LIBRARIES_PATHMAP), umlResourcePluginURI.appendSegment(\"libraries\").appendSegment(\"\"));" + NL + "\t\turiMap.put(URI.createURI(UMLResource.METAMODELS_PATHMAP), umlResourcePluginURI.appendSegment(\"metamodels\").appendSegment(\"\"));" + NL + "\t\turiMap.put(URI.createURI(UMLResource.PROFILES_PATHMAP), umlResourcePluginURI.appendSegment(\"profiles\").appendSegment(\"\"));" + NL + "" + NL + "\t\t// registerExtensions" + NL + "\t\tret.getResourceFactoryRegistry().getExtensionToFactoryMap().put(UMLResource.FILE_EXTENSION, UMLResource.Factory.INSTANCE);" + NL + "\t\tret.getResourceFactoryRegistry().getExtensionToFactoryMap().put(Ecore2XMLResource.FILE_EXTENSION, Ecore2XMLResource.Factory.INSTANCE);" + NL + "    \tret.getResourceFactoryRegistry().getExtensionToFactoryMap().put(UML22UMLResource.FILE_EXTENSION, UML22UMLResource.Factory.INSTANCE);" + NL + "\t\t" + NL + "\t\t// register package" + NL + "    \tret.getPackageRegistry().put(EcorePackage.eNS_URI, EcorePackage.eINSTANCE);" + NL + "    \tret.getPackageRegistry().put(Ecore2XMLPackage.eNS_URI, Ecore2XMLPackage.eINSTANCE);" + NL + "    \tret.getPackageRegistry().put(UMLPackage.eNS_URI, UMLPackage.eINSTANCE);" + NL + "    \tret.getPackageRegistry().put(\"http://www.eclipse.org/uml2/2.0.0/UML\", UMLPackage.eINSTANCE);" + NL + "    \tEPackage.Registry.INSTANCE.put(\"http://www.eclipse.org/uml2/2.0.0/UML\", UMLPackage.eINSTANCE);" + NL + "" + NL + "\t\turiMap = UML22UMLExtendedMetaData.getURIMap();" + NL + "\t\tret.getURIConverter().getURIMap().putAll(uriMap);" + NL + "\t\t" + NL + "\t\tURI umlPluginURI = URI.createURI(\"jar:file:/";
  protected final String TEXT_30 = "!/\");" + NL + "\t\tURIConverter.URI_MAP.put(URI.createURI(\"platform:/plugin/org.eclipse.uml2.uml/\"), umlPluginURI);" + NL + "\t\t";
  protected final String TEXT_31 = NL + "\t\treturn ret;" + NL + "\t}" + NL + "}";
  protected final String TEXT_32 = NL;

  public String generate(Object argument)
  {
    final StringBuffer stringBuffer = new StringBuffer();
    
 AcceleoExportToStandaloneTemplateModel content = (AcceleoExportToStandaloneTemplateModel) argument;

    stringBuffer.append(TEXT_1);
    if(content.getPackageName() != null && content.getPackageName().length() > 0){
    stringBuffer.append(TEXT_2);
    stringBuffer.append(content.getPackageName());
    stringBuffer.append(TEXT_3);
    }
    stringBuffer.append(TEXT_4);
    if(content.isUmlModel()){
    stringBuffer.append(TEXT_5);
    }
    stringBuffer.append(TEXT_6);
    if(content.isEcoreModel() && !content.isUmlModel()){
    stringBuffer.append(TEXT_7);
    }else{
    stringBuffer.append(TEXT_8);
    }
    stringBuffer.append(TEXT_9);
    if(content.isUmlModel()){
    stringBuffer.append(TEXT_10);
    }
    stringBuffer.append(TEXT_11);
    stringBuffer.append(content.getEmtName());
    stringBuffer.append(TEXT_12);
    stringBuffer.append(content.getEmtFile());
    stringBuffer.append(TEXT_13);
    stringBuffer.append(content.getEmtFile());
    stringBuffer.append(TEXT_14);
    if(content.isEcoreModel() && !content.isUmlModel()){
    stringBuffer.append(TEXT_15);
    stringBuffer.append(content.getEmtName());
    stringBuffer.append(TEXT_16);
    stringBuffer.append(content.getEcorePath());
    stringBuffer.append(TEXT_17);
    }else{
    stringBuffer.append(TEXT_18);
    stringBuffer.append(content.getModelPackageName());
    stringBuffer.append(TEXT_19);
    }
    stringBuffer.append(TEXT_20);
    stringBuffer.append(content.getEmtFile());
    stringBuffer.append(TEXT_21);
    if(content.isEcoreModel() && !content.isUmlModel()){
    stringBuffer.append(TEXT_22);
    stringBuffer.append(content.getEmtName());
    stringBuffer.append(TEXT_23);
    stringBuffer.append(content.getEcorePath());
    stringBuffer.append(TEXT_24);
    }else{
    stringBuffer.append(TEXT_25);
    stringBuffer.append(content.getModelPackageName());
    stringBuffer.append(TEXT_26);
    }
    stringBuffer.append(TEXT_27);
    if(content.isUmlModel()){
    stringBuffer.append(TEXT_28);
    stringBuffer.append(content.getUmlResourcesJarPath());
    stringBuffer.append(TEXT_29);
    stringBuffer.append(content.getUmlJarPath());
    stringBuffer.append(TEXT_30);
    }
    stringBuffer.append(TEXT_31);
    stringBuffer.append(TEXT_32);
    return stringBuffer.toString();
  }
}
